
||----------------------------------------------------------------------|| 
||									||
||	top_level.m 							||
||									||
||	Putting together the basic semantics and the examples.		||
||									||
||	(c) Simon Thompson, 1995					||
||									||
||----------------------------------------------------------------------|| 

%include "semantics"

%include "new_examples"

||	%include "pretty"

run :: command -> stores -> [char]

run c st = "initial store:\n" ++ show_store st ++ "\n" ++
	   "final store:\n" ++ show_final (command_value c st)

show_final :: stores -> [char]

show_final = show_store . get_final

get_final :: stores -> stores

get_final [] = []
get_final ((a,b):rest) = (a,b) : get_final [ (c,d) | (c,d) <- rest ; c~=a ]

show_store :: stores -> [char]

show_num :: num -> [char]
show_num = show

show_store = concat . (map show_pair)
		where
		show_pair (Name a,b) = "\t" ++ a ++ "\t" ++ show_num b ++ "\n"

