||----------------------------------------------------------------------|| 
||									||
||	top_level.m							||
||									||
||	Interpreting commands in an operational style.			||
||	Top level file - includes examples and pretty printing.		||
||									||
||	(c) Simon Thompson, 1995					||
||									||
||----------------------------------------------------------------------|| 

%include "abstract_syntax"
%include "semantic_types" 

%insert "sem_fun_types.ins"
%insert "expr_values.ins"
%insert "command_opr.ins"

%include "examples"
%include "pretty"

||----------------------------------------------------------------------|| 
||									||
||	When run is applied to a command (see examples.m) it 		||
||	produces a printable version of the computation sequence	||
||	Each configuration is printed					||
||		command							||
||		state							||
||	in the final state the command part being `Final'.		||
||									||
||	Try run on example and example3.				||
||									||
||----------------------------------------------------------------------|| 

run :: command -> [char]

run c = show_comp (computation (Inter c []))

